------------------------------------------------------------------------------
--                               GNAT Studio                                --
--                                                                          --
--                       Copyright (C) 2019-2023, AdaCore                   --
--                                                                          --
-- This is free software;  you can redistribute it  and/or modify it  under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 3,  or (at your option) any later ver- --
-- sion.  This software is distributed in the hope  that it will be useful, --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public  License  distributed  with  this  software;   see  file --
-- COPYING3.  If not, go to http://www.gnu.org/licenses for a complete copy --
-- of the license.                                                          --
------------------------------------------------------------------------------
--  Implementation of the "shutdown" request for the language server.

with GPS.LSP_Client.Requests.Shutdown;

private package GPS.LSP_Clients.Shutdowns is

   ----------------------
   -- Shutdown_Request --
   ----------------------

   type Shutdown_Request
     (Client : not null access LSP_Client'Class) is
     new GPS.LSP_Client.Requests.Shutdown.Abstract_Shutdown_Request
       with null record;

   overriding procedure On_Result_Message (Self : in out Shutdown_Request);
   --  Handles result messages for shutdown request.

end GPS.LSP_Clients.Shutdowns;
